/*
 * Copyright (c) 2008, WSO2 Inc. (http://www.wso2.org) All Rights Reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.wso2.registry.app;

import org.apache.abdera.util.AbstractExtensionFactory;
import org.wso2.registry.RegistryConstants;

import javax.xml.namespace.QName;

public class PropertyExtensionFactory extends AbstractExtensionFactory {
    public static final QName PROPERTY_NAME =
            new QName(RegistryConstants.REGISTRY_NAMESPACE, "name", "ns");
    public static final QName PROPERTY_VALUE =
            new QName(RegistryConstants.REGISTRY_NAMESPACE, "value", "ns");
    public static final QName PROPERTIES =
            new QName(RegistryConstants.REGISTRY_NAMESPACE, "properties", "ns");
    public static final QName PROPERTY =
            new QName(RegistryConstants.REGISTRY_NAMESPACE, "property", "ns");
    public static final QName TAGS = new QName(RegistryConstants.REGISTRY_NAMESPACE, "tags", "ns");
    public static final QName TAG = new QName(RegistryConstants.REGISTRY_NAMESPACE, "tag", "ns");

    public PropertyExtensionFactory() {
        super(RegistryConstants.REGISTRY_NAMESPACE);
        addImpl(PROPERTY_NAME, PropertyName.class);
        addImpl(PROPERTY_VALUE, PropertyValue.class);
        addImpl(PROPERTIES, Properties.class);
        addImpl(TAGS, Properties.class);
        addImpl(PROPERTY, Property.class);
        addImpl(TAG, Property.class);
    }

}
