package org.wso2.registry.users.hybrid;

import javax.sql.DataSource;

import org.wso2.authenticator.Authenticator;
import org.wso2.registry.users.UserStoreAdmin;
import org.wso2.registry.users.UserStoreReader;

public class HybridRealmConfig {
    
    /** Authenticator */
    private Authenticator authenticator = null;
    
    /** UserStoreAdmin */
    private UserStoreAdmin userStoreAdmin = null;

    /** UserStoreReader */
    private UserStoreReader userStoreReader = null;

    /**
     * This algorithm checks users permission only when validating
     * User Authorizations
     */
    public static final String PERMISSION_USER_ONLY = "USER_ONLY";

    /**
     * This algorithm also checks role authorization when validating
     * User Authorization
     */
    public static final String PERMISSION_BLOCK_FIRST = "BLOCK_FIRST";

    /**Database connection user name*/
    private String connectionUserName = null;

    /**Database connection url*/
    private String connectionURL = null;

    /**Database connection password*/
    private String connectionPassword = null;

    /**Database driver*/
    private String driverName = null;

    /**DBCP data source*/
    private DataSource dataSource = null;

    /**The algorithm holds the permission algorithm*/
    private String permissionAlgo = PERMISSION_BLOCK_FIRST;

    /**Maximum connection count*/
    private int maxConnectionsCount = 5;
    
    private Object configObject = null;
    
    public Authenticator getAuthenticator() {
        return authenticator;
    }

    public void setAuthenticator(Authenticator authenticator) {
        this.authenticator = authenticator;
    }

    public UserStoreAdmin getUserStoreAdmin() {
        return userStoreAdmin;
    }

    public void setUserStoreAdmin(UserStoreAdmin userStoreAdmin) {
        this.userStoreAdmin = userStoreAdmin;
    }

    public UserStoreReader getUserStoreReader() {
        return userStoreReader;
    }

    public void setUserStoreReader(UserStoreReader userStoreReader) {
        this.userStoreReader = userStoreReader;
    }

    public DataSource getDataSource() {
        return dataSource;
    }

    public void setDataSource(DataSource dataSource) {
        this.dataSource = dataSource;
    }

    public String getConnectionUserName() {
        return connectionUserName;
    }

    public void setConnectionUserName(String connectionUserName) {
        this.connectionUserName = connectionUserName;
    }

    public String getConnectionURL() {
        return connectionURL;
    }

    public void setConnectionURL(String connectionURL) {
        this.connectionURL = connectionURL;
    }

    public String getConnectionPassword() {
        return connectionPassword;
    }

    public void setConnectionPassword(String connectionPassword) {
        this.connectionPassword = connectionPassword;
    }

    public String getDriverName() {
        return driverName;
    }

    public void setDriverName(String driverName) {
        this.driverName = driverName;
    }

    public String getPermissionAlgo() {
        return permissionAlgo;
    }

    public void setPermissionAlgo(String permissionAlgo) {
        this.permissionAlgo = permissionAlgo;
    }

    public int getMaxConnectionsCount() {
        return maxConnectionsCount;
    }

    public void setMaxConnectionsCount(int maxConnectionsCount) {
        this.maxConnectionsCount = maxConnectionsCount;
    }

    public Object getConfigObject() {
        return configObject;
    }

    public void setConfigObject(Object configObject) {
        this.configObject = configObject;
    }
       
    
}
