/*
 * Copyright (c) 2007, WSO2 Inc. (http://www.wso2.org) All Rights Reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.wso2.registry.app;

import junit.framework.TestCase;
import org.wso2.registry.Registry;

import java.net.URL;

public class AbstractAPPTest extends TestCase {
    public static final String PORT = "8081";

    RegistryServer server;
    Registry registry;
    
    int clientPort = 8081;
    String baseURL;

    public AbstractAPPTest() {
        String portProp = System.getProperty("clientPort");
        if (portProp != null) {
            clientPort = Integer.parseInt(portProp);
        }
    }

    public AbstractAPPTest(String name) {
        super(name);
        String portProp = System.getProperty("clientPort");
        if (portProp != null) {
            clientPort = Integer.parseInt(portProp);
        }
    }

    protected void setUp() throws Exception {
        baseURL = "http://localhost:" + clientPort + "/wso2registry/";
        if (server == null) {
            server = new RegistryServer(Integer.parseInt(PORT));
            server.setPort(Integer.parseInt(PORT));
            server.start();
        }
        registry = new RemoteRegistry(new URL(baseURL), "admin", "admin");
    }

    protected void tearDown() throws Exception {
        server.stop();
        server = null;
    }
}
