/*
 * Copyright (c) 2006, WSO2 Inc. (http://www.wso2.org) All Rights Reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.wso2.registry.jdbc;

import junit.framework.TestCase;
import org.wso2.registry.Registry;
import org.wso2.registry.RegistryConstants;
import org.wso2.registry.Resource;
import org.wso2.registry.exceptions.RegistryException;
import org.wso2.registry.jdbc.realm.RegistryRealm;

public class ResourcesTest extends TestCase {

    protected static EmbeddedRegistry embeddedRegistry = null;
    protected static Registry registry = null;
    protected static RegistryRealm realm = null;

    public void setUp() throws RegistryException {
        if (registry == null) {
            embeddedRegistry = new InMemoryEmbeddedRegistry();
            registry = embeddedRegistry.getUserRegistry(
                    RegistryConstants.ADMIN_USER, RegistryConstants.ADMIN_PASSWORD);
        }
    }

    public void testResourceUpdate() throws RegistryException {

        String r1Path = "/rtest/r1";
        Resource r1 = registry.newResource();
        r1.setContent("c1");
        r1.setProperty("p1", "v1");
        registry.put(r1Path, r1);

        Resource r1e1 = registry.get(r1Path);
        r1e1.setProperty("p1", "v2");
        registry.put(r1Path, r1e1);

        Resource r1e2 = registry.get(r1Path);
        assertNotNull("r1 content should not be null", r1e2.getContent());

        String r1e2Content = new String((byte[]) r1e2.getContent());
        assertEquals("r1 content should be c1", r1e2Content, "c1");
    }
}
