/*
 * Copyright (c) 2008, WSO2 Inc. (http://www.wso2.org) All Rights Reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.wso2.registry.web.actions;

import org.wso2.registry.Registry;
import org.wso2.registry.exceptions.RegistryException;

import javax.servlet.http.HttpServletRequest;

public class AddTagAction extends AbstractRegistryAction {

    private String path;
    private String tag;

    public String execute(HttpServletRequest request) throws RegistryException {

        setRequest(request);

        if (path == null || path.length() == 0) {
            return ERROR;
        }

        if (tag == null || tag.length() == 0) {
            return ERROR;
        }

        Registry reg = getRegistry();

        reg.applyTag(path, tag);

        return SUCCESS;
    }

    public String getPath() {
        return path;
    }

    public void setPath(String path) {

        // we are handling only the current version in the human view
        if (path.indexOf("?") > 0) {
            path = path.split("\\?")[0];
        }

        this.path = path;
    }

    public String getTag() {
        return tag;
    }

    public void setTag(String tag) {
        this.tag = tag;
    }
}
