/*
 * Copyright (c) 2008, WSO2 Inc. (http://www.wso2.org) All Rights Reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.wso2.registry.web.actions;

import org.wso2.registry.Registry;
import org.wso2.registry.RegistryConstants;
import org.wso2.registry.exceptions.RegistryException;

import javax.servlet.http.HttpServletRequest;

public class DeleteResourceAction extends AbstractRegistryAction {

    /**
     * Path of the resource to be deleted.
     */
    private String pathToDelete;

    public String execute(HttpServletRequest request) throws Exception {

        setRequest(request);

        if (pathToDelete == null || pathToDelete.length() == 0) {
            return ERROR;
        }

        if (pathToDelete.equals(RegistryConstants.ROOT_PATH)) {
            return SUCCESS;
        }

        Registry registry = getRegistry();

        try {
            registry.delete(pathToDelete);
        } catch (RegistryException e) {
            return ERROR;
        }

        return SUCCESS;
    }    

    public String getPathToDelete() {
        return pathToDelete;
    }

    public void setPathToDelete(String pathToDelete) {
        this.pathToDelete = pathToDelete;
    }
}
