/*
 * Copyright (c) 2008, WSO2 Inc. (http://www.wso2.org) All Rights Reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.wso2.registry.web.actions;

import org.wso2.registry.Registry;
import org.wso2.registry.exceptions.RegistryException;

public class RateAction extends AbstractRegistryAction {

    private String path;
    private String rating;

    public String execute() throws RegistryException {

        if (path == null || path.length() == 0) {
            return ERROR;
        }

        if (rating == null || rating.length() == 0) {
            return ERROR;
        }

        int ratingValue = Integer.parseInt(rating);

        Registry registry = getRegistry();

        registry.rateResource(path, ratingValue);

        return SUCCESS;
    }

    public String getPath() {
        return path;
    }

    public void setPath(String path) {
        this.path = path;
    }

    public String getRating() {
        return rating;
    }

    public void setRating(String rating) {
        this.rating = rating;
    }
}
