package org.wso2.registry.web.actions;

import org.wso2.registry.Collection;
import org.wso2.registry.Registry;
import org.wso2.registry.RegistryConstants;
import org.wso2.registry.Resource;
import org.wso2.registry.exceptions.RegistryException;
import org.wso2.registry.web.actions.utils.ResourceData;


import javax.servlet.http.HttpServletRequest;
import java.util.*;

/**
 * Created by IntelliJ IDEA.
 * User: chanaka jayasena
 * Date: May 11, 2008
 * Time: 1:47:55 PM
 * To change this template use File | Settings | File Templates.
 */
/*
 * Copyright (c) 2008, WSO2 Inc. (http://www.wso2.org) All Rights Reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */





public class ShowResourceTreeAction extends AbstractRegistryAction {

//    private Log log = LogFactory.getLog(CollectionViewAction.class);

    private String path;
    private List resourceDataList = new ArrayList();
    private String parentPath;
    private String status;
    private String errorMessage;
    private List navigatablePaths = new ArrayList();
    private List collectionTypes = new ArrayList();
    private String resourceTree = "";
    private int resourceTreeIndex = 1;
    private String textBoxId;

    public String execute(HttpServletRequest request) throws RegistryException {

        setRequest(request);

        // get the resource for the path
        // get all its children and fill ResourceOverview objects
        // add ResourceOverview object to the resourceDataList list


        fillResourceTree(RegistryConstants.ROOT_PATH);

        //Fill the resourceTree String with html data

        status = "success";
        return SUCCESS;
    }

    public void fillResourceTree(String resourcePath) {
        try {

            Registry registry = getRegistry();
            String[] childPaths = {""};
            Resource resource;
            String resourceName = "";
            String resourceType;
            boolean hasChildren = false;

            resource = registry.get(resourcePath);
            resourceType = resource instanceof Collection ? ResourceData.COLLECTION : ResourceData.RESOURCE;
            if (resourceType.equals(ResourceData.COLLECTION)) {
                childPaths = (String[]) resource.getContent();
                if (childPaths.length > 0) hasChildren = true;
            }
            if (!resourcePath.equals(RegistryConstants.ROOT_PATH)) {
                if (resourcePath != null) {
                    String[] parts = resourcePath.split(RegistryConstants.PATH_SEPARATOR);
                    resourceName = parts[parts.length - 1];
                }
            } else {
                resourceName = "/";
            }


            resourceTreeIndex++;
            resourceTree += "<div class=\"father-object\">";
            if (resourceType != ResourceData.RESOURCE) {
                resourceTree += "<a onclick=\"showHideCommon('y_plus_" + resourceTreeIndex + "');showHideCommon('y_minus_" + resourceTreeIndex + "');showHideCommon('z_" + resourceTreeIndex + "');\">";
                if (hasChildren) {
                    resourceTree += "<img src=\"/wso2registry/admin/images/icon-tree-plus.jpg\" id=\"y_plus_" + resourceTreeIndex + "\" style=\"display:none;margin-right:5px;\" />" +
                            "<img src=\"/wso2registry/admin/images/icon-tree-minus.jpg\" id=\"y_minus_" + resourceTreeIndex + "\" style=\"margin-right:5px;\" />";
                } else {
                    resourceTree += "<img src=\"/wso2registry/admin/images/spacer.gif\" style=\"width:20px;height:10px;\" />";
                }
                resourceTree += "<a onclick=\"pickPath('" + resourcePath + "')\">" +
                        "<img src=\"/wso2registry/admin/images/icon-folder-small.gif\" style=\"margin-right:2px;\" />" +
                        resourceName +
                        "</a>";
            } else {
                resourceTree += "<a class=\"plane-resource\" onclick=\"pickPath('" + resourcePath + "')\">" + "<img src=\"/wso2registry/admin/images/spacer.gif\" style=\"width:20px;height:10px;\" />" + resourceName + "</a>";
            }
            resourceTree += "</div>" + "<div class=\"child-objects\" id=\"z_" + resourceTreeIndex + "\">";
            if (resourceType == ResourceData.RESOURCE) {
                resourceTree += "</div>";
                return;
            } else {
                if (!hasChildren) {
                    resourceTree += "</div>";
                    return;
                } else {

                    for (int i = 0; childPaths.length > i; i++) {
                        //Recursive call
                        fillResourceTree(childPaths[i]);
                    }
                }
            }
            resourceTree += "</div>";
        } catch (RegistryException e) {
            e.printStackTrace();  //To change body of catch statement use File | Settings | File Templates.

        }

    }


    public String getPath() {
        return path;
    }

    public void setPath(String path) {

        // we are handling only the current version in the human view
        //if (path.indexOf("?") > 0) {
        //    path = path.split("\\?")[0];
        //}

        this.path = path;
    }

    public String getResourceTree() {
        return resourceTree;
    }

    public void setResourceTree(String resourceTree) {
        this.resourceTree = resourceTree;
    }

    public List getResourceDataList() {
        return resourceDataList;
    }

    public void setResourceDataList(List resourceDataList) {
        this.resourceDataList = resourceDataList;
    }

    public String getParentPath() {
        return parentPath;
    }

    public void setParentPath(String parentPath) {
        this.parentPath = parentPath;
    }

    public String getStatus() {
        return status;
    }

    public void setStatus(String status) {
        this.status = status;
    }

    public String getErrorMessage() {
        return errorMessage;
    }

    public void setErrorMessage(String errorMessage) {
        this.errorMessage = errorMessage;
    }

    public List getNavigatablePaths() {
        return navigatablePaths;
    }

    public void setNavigatablePaths(List navigatablePaths) {
        this.navigatablePaths = navigatablePaths;
    }

    public List getCollectionTypes() {
        return collectionTypes;
    }

    public void setCollectionTypes(List collectionTypes) {
        this.collectionTypes = collectionTypes;
    }

    public String getTextBoxId() {
        return textBoxId;
    }

    public void setTextBoxId(String textBoxId) {
        this.textBoxId = textBoxId;
    }

}

