/*
 * Copyright (c) 2006, WSO2 Inc. (http://www.wso2.org) All Rights Reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.wso2.registry.web.builders;

import org.wso2.registry.web.populators.CommonBeanPopulator;
import org.wso2.registry.web.populators.VersionsBeanPopulator;
import org.wso2.registry.web.utils.CommonUtil;
import org.wso2.registry.web.UIConstants;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

public class VersionsPageBuilder {

    public static void build(
            HttpServletRequest request, HttpServletResponse response, String path) {

        CommonBeanPopulator.populate(request, null);
        VersionsBeanPopulator.populate(request, path);

        CommonUtil.forwardToPage(request, response, UIConstants.VERSIONS_JSP);
    }
}
