/*
 * Copyright (c) 2006, WSO2 Inc. (http://www.wso2.org) All Rights Reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.wso2.registry.web.populators;

import org.wso2.registry.web.beans.PropertiesBean;
import org.wso2.registry.web.UIConstants;
import org.wso2.registry.Resource;
import org.wso2.registry.Aspect;
import org.wso2.registry.Collection;

import javax.servlet.http.HttpServletRequest;
import java.util.*;

public class PropertiesBeanPopulator {

    public static void populate(HttpServletRequest request, Resource resource) {

        PropertiesBean propertiesBean = new PropertiesBean();

        propertiesBean.setProperties(resource.getProperties());

        Boolean viewSysProps = (Boolean) request.
                getSession().getAttribute(UIConstants.SHOW_SYSPROPS_ATTR);

        Iterator iTmpProps = resource.getProperties().keySet().iterator();

        List <String> sysProperties = new ArrayList <String> ();
        List <String> validationProperties = new ArrayList <String> ();
        List <String> lifecycleProperties = new ArrayList <String> ();
        Map<String, String> browseViews = new HashMap <String, String> ();
        Map<String, String> editViews = new HashMap <String, String> ();

        while (iTmpProps.hasNext()) {
            String name = (String) iTmpProps.next();

            if ((viewSysProps != null && viewSysProps) || !name.startsWith("registry.")) {
                sysProperties.add(name);
            }

            if (name.startsWith("registry.wsdl") || name.startsWith("registry.wsi")) {
                validationProperties.add(name);

            } else if (name.startsWith("registry.lifecycle.") ||
                    name.equals(Aspect.AVAILABLE_ASPECTS)) {

                lifecycleProperties.add(name);

            } else if (name.equals("registry.browse-view")) {

                //String val = (String) propertiesBean.getProperties().get(name);
                //String[] parts = val.split(":");
                //browseViews.put(parts[0], parts[1]);

            } else if (name.equals("registry.edit-view")) {

                //String val = (String) propertiesBean.getProperties().get(name);
                //String[] parts = val.split(":");
                //editViews.put(parts[0], parts[1]);
            }
        }

        Collections.sort(sysProperties);

        propertiesBean.setSysProperties(sysProperties);
        propertiesBean.setValidationProperties(validationProperties);
        propertiesBean.setLifecycleProperties(lifecycleProperties);

        request.getSession().setAttribute(UIConstants.PROPERTIES_BEAN, propertiesBean);
    }
}
