/*
 * Copyright (c) 2006, WSO2 Inc. (http://www.wso2.org) All Rights Reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.wso2.registry.web.processors;

import org.wso2.registry.session.UserRegistry;
import org.wso2.registry.users.UserRealm;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

public class AddRoleProcessor extends UIProcessor {

    public void process(HttpServletRequest request, HttpServletResponse response) {

        String newRoleName = request.getParameter("newRoleName");
        if (newRoleName == null || newRoleName.equalsIgnoreCase("-- None --")) {
            String msg = "Failed to add the new role " +
                    newRoleName + ". Required parameters are missing";
            log.error(msg);
            sendErrorContent(response, msg);
            return;
        }

        try {
            UserRegistry userRegistry = getUserRegistry(request);
            UserRealm userRealm = userRegistry.getUserRealm();

            userRealm.getUserStoreAdmin().addRole(newRoleName);

        } catch (Exception e) {
            String msg = "Failed to add the new role " + newRoleName + ". " + e.getMessage();
            log.error(msg, e);
            sendErrorContent(response, msg);
            return;
        }

        redirect(response, "/wso2registry/people");
    }
}
