/*
 * Copyright (c) 2006, WSO2 Inc. (http://www.wso2.org) All Rights Reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.wso2.registry.web.processors;

import org.wso2.registry.session.UserRegistry;
import org.wso2.registry.users.UserRealm;
import org.wso2.registry.web.populators.UserBeanPopulator;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

public class AddUserRoleProcessor extends UIProcessor {

    public void process(HttpServletRequest request, HttpServletResponse response) {

        String userName = request.getParameter("userName");
        String roleName = request.getParameter("roleToAdd");

        if (roleName.equals("1")) {
            redirect(response, "/wso2registry/people/" + userName);
        }

        try {
            UserRegistry userRegistry = getUserRegistry(request);
            UserRealm realm = userRegistry.getUserRealm();
            realm.getUserStoreAdmin().addUserToRole(userName, roleName);

            UserBeanPopulator.populate(request, userName);
            redirect(response, "/wso2registry/people/" + userName);

        } catch (Exception e) {
            String msg = "Failed to add the user " + userName + " to the role " + roleName +
                    ". Caused by: " + e.getMessage();
            log.error(msg, e);
            addErrorMessage(request, msg);
            redirect(response, "/wso2registry/people/" + userName);
        }
    }
}
