/*
 * Copyright (c) 2006, WSO2 Inc. (http://www.wso2.org) All Rights Reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.wso2.registry.web.processors;

import org.wso2.registry.Tag;
import org.wso2.registry.exceptions.RegistryException;
import org.wso2.registry.session.UserRegistry;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

public class GetTagCloudProcessor extends UIProcessor {

    public void process(HttpServletRequest request, HttpServletResponse response) {

        String resourcePath = request.getParameter("resourcePath");
        Tag[] tags;
        try {
            UserRegistry userRegistry = getUserRegistry(request);
            tags = userRegistry.getTags(resourcePath);

        } catch (RegistryException e) {

            String msg = "Failed to get tags of resource " + resourcePath + ". " + e.getMessage();
            log.error(msg, e);
            sendErrorContent(response, msg);
            return;
        }

        //if (message != null && message.length() > 0) {
        //    out.println(message + "<br/>");
        //}

        StringBuffer tagBuf = new StringBuffer();
        for (int i = 0; i < tags.length; i++) {
            Tag tag = tags[i];
            tagBuf.append("<a href='/wso2registry/search?criteria=" + tag.getTagName() + "&searchType=tag' class='cloud-x" + tag.getCategory() + "'>" + tag.getTagName() + "</a>");
        }

        response.setContentType("text/html");
        sendContent(response, tagBuf.toString());
    }
}
