/*
 * Copyright (c) 2006, WSO2 Inc. (http://www.wso2.org) All Rights Reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.wso2.registry.web.processors;

import org.wso2.registry.session.UserRegistry;
import org.wso2.registry.users.UserRealm;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

public class RemoveUserProcessor extends UIProcessor {

    public void process(HttpServletRequest request, HttpServletResponse response) {

        String userName = request.getParameter("user");

        if (userName == null) {
            String msg = "Failed to delete user. User name is empty.";
            log.error(msg);
            addErrorMessage(request, msg);
            redirect(response, "/wso2registry/people");
            return;
        }

        try {
            UserRegistry userRegistry = getUserRegistry(request);
            UserRealm userRealm = userRegistry.getUserRealm();
            userRealm.getUserStoreAdmin().deleteUser(userName);

        } catch (Exception e) {

            String msg = "Failed to remove the user: " + userName + ". Caused by: " + e.getMessage();
            log.error(msg, e);
            addErrorMessage(request, msg);
            redirect(response, "/wso2registry/people");
        }
    }
}
