package org.wso2.registry.web.utils;

import org.wso2.registry.Association;
import org.wso2.registry.Registry;
import org.wso2.registry.ResourcePath;
import org.wso2.registry.session.UserRegistry;
import org.wso2.registry.exceptions.RegistryException;
import org.wso2.registry.web.UIConstants;
import org.wso2.registry.web.populators.DependenciesBeanPopulator;
import org.wso2.registry.web.actions.ResourceDetailsAction;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

public class AssociationUtil {
    public static void addRemoveAssociation(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {

        String resourcePath = request.getParameter("resourcePath");

        try {


            String associationType = request.getParameter("type");
            String associationPaths = request.getParameter("associationPaths");
            String todo = request.getParameter("todo");
            UserRegistry registry = CommonUtil.getUserRegistry(request);

            if(todo.equals("add")){
                registry.addAssociation(resourcePath, associationPaths, associationType);
            } else {
               registry.removeAssociation(resourcePath, associationPaths, associationType);
            }

            Association[] deps = registry.getAllAssociations(resourcePath);
            List assoList = new ArrayList();
            assoList.addAll(Arrays.asList(deps));

            ResourcePath path = new ResourcePath(resourcePath);
            DependenciesBeanPopulator.populate(request, registry, path);

            if(associationType.equals(UIConstants.ASSOCIATION_TYPE01)) {
                request.getSession().setAttribute("type","dep");
            } else{
                request.getSession().setAttribute("type","asso");
            }

            request.getRequestDispatcher(UIConstants.AJAX_ASSOCIATIONS_JSP)
                    .forward(request, response);
        } catch (RegistryException e) {
            request.getSession().setAttribute(UIConstants.ERROR_MESSAGE, e.getMessage());

        }
    }
}
