/*
 * Copyright (c) 2008, WSO2 Inc. (http://www.wso2.org) All Rights Reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.wso2.registry.web.utils;

import org.wso2.registry.Registry;
import org.wso2.registry.exceptions.RegistryException;
import org.wso2.registry.Comment;
import org.wso2.registry.web.UIConstants;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.ServletException;
import java.util.List;
import java.util.ArrayList;
import java.io.IOException;

public class CommentsUtil {

    public static void addComment(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {

        try {

            String resourcePath = request.getParameter("resourcePath");
            String commentText = request.getParameter("comment");
            Registry registry = CommonUtil.getUserRegistry(request);
            registry.addComment(resourcePath, new Comment(commentText));

            Comment[] comments = registry.getComments(resourcePath);
            List commentList = new ArrayList();
            for (Comment comment : comments) {
                commentList.add(comment);
            }

            request.getSession().setAttribute(UIConstants.AJAX_COMMENTS_LIST, commentList);

        } catch (RegistryException e) {
            request.getSession().setAttribute(UIConstants.ERROR_MESSAGE, e.getMessage());
        }

        request.getRequestDispatcher(UIConstants.AJAX_COMMENTS_JSP).forward(request, response);
    }
}
